package org.dromara.elevator.service.impl;

import org.dromara.common.core.exception.ServiceException;
import org.dromara.common.core.utils.MapstructUtils;
import org.dromara.common.core.utils.StringUtils;
import org.dromara.common.mybatis.core.page.TableDataInfo;
import org.dromara.common.mybatis.core.page.PageQuery;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import lombok.RequiredArgsConstructor;
import org.dromara.elevator.domain.EBlackBoxInfo;
import org.springframework.stereotype.Service;
import org.dromara.elevator.domain.bo.EBuildingInfoBo;
import org.dromara.elevator.domain.vo.EBuildingInfoVo;
import org.dromara.elevator.domain.EBuildingInfo;
import org.dromara.elevator.mapper.EBuildingInfoMapper;
import org.dromara.elevator.service.IEBuildingInfoService;

import java.util.List;
import java.util.Map;
import java.util.Collection;

/**
 * 楼宇基础信息;Service业务层处理
 *
 * @author zy
 * @date 2024-07-29
 */
@RequiredArgsConstructor
@Service
public class EBuildingInfoServiceImpl implements IEBuildingInfoService {

    private final EBuildingInfoMapper baseMapper;

    /**
     * 查询楼宇基础信息;
     *
     * @param id 主键
     * @return 楼宇基础信息;
     */
    @Override
    public EBuildingInfoVo queryById(Long id){
        return baseMapper.selectVoById(id);
    }

    /**
     * 分页查询楼宇基础信息;列表
     *
     * @param bo        查询条件
     * @param pageQuery 分页参数
     * @return 楼宇基础信息;分页列表
     */
    @Override
    public TableDataInfo<EBuildingInfoVo> queryPageList(EBuildingInfoBo bo, PageQuery pageQuery) {
        LambdaQueryWrapper<EBuildingInfo> lqw = buildQueryWrapper(bo);
        Page<EBuildingInfoVo> result = baseMapper.selectVoPage(pageQuery.build(), lqw);
        return TableDataInfo.build(result);
    }

    /**
     * 查询符合条件的楼宇基础信息;列表
     *
     * @param bo 查询条件
     * @return 楼宇基础信息;列表
     */
    @Override
    public List<EBuildingInfoVo> queryList(EBuildingInfoBo bo) {
        LambdaQueryWrapper<EBuildingInfo> lqw = buildQueryWrapper(bo);
        return baseMapper.selectVoList(lqw);
    }

    private LambdaQueryWrapper<EBuildingInfo> buildQueryWrapper(EBuildingInfoBo bo) {
        Map<String, Object> params = bo.getParams();
        LambdaQueryWrapper<EBuildingInfo> lqw = Wrappers.lambdaQuery();
        lqw.eq(StringUtils.isNotBlank(bo.getProjectId()), EBuildingInfo::getProjectId, bo.getProjectId());
        lqw.eq(StringUtils.isNotBlank(bo.getCode()), EBuildingInfo::getCode, bo.getCode());
        lqw.like(StringUtils.isNotBlank(bo.getName()), EBuildingInfo::getName, bo.getName());
        lqw.orderByDesc(EBuildingInfo::getCreateTime);
        return lqw;
    }

    /**
     * 新增楼宇基础信息;
     *
     * @param bo 楼宇基础信息;
     * @return 是否新增成功
     */
    @Override
    public Boolean insertByBo(EBuildingInfoBo bo) {
        EBuildingInfo add = MapstructUtils.convert(bo, EBuildingInfo.class);
        validEntityBeforeSave(add);
        boolean flag = baseMapper.insert(add) > 0;
        if (flag) {
            bo.setId(add.getId());
        }
        return flag;
    }

    /**
     * 修改楼宇基础信息;
     *
     * @param bo 楼宇基础信息;
     * @return 是否修改成功
     */
    @Override
    public Boolean updateByBo(EBuildingInfoBo bo) {
        EBuildingInfo update = MapstructUtils.convert(bo, EBuildingInfo.class);
        validEntityBeforeUpdate(update);
        return baseMapper.updateById(update) > 0;
    }

    /**
     * 保存前的数据校验
     */
    private void validEntityBeforeSave(EBuildingInfo entity){
        // 校验编号是否存在
        LambdaQueryWrapper<EBuildingInfo> num = Wrappers.lambdaQuery();
        num.eq(StringUtils.isNotBlank(entity.getCode()), EBuildingInfo::getCode, entity.getCode());
        List<EBuildingInfoVo> infoVoList = baseMapper.selectVoList(num);
        if (!infoVoList.isEmpty()) {
            throw new ServiceException("该楼栋编号已存在!");
        }

        //TODO 做一些数据校验,如唯一约束
    }

    /**
     * 更新前的数据校验
     */
    private void validEntityBeforeUpdate(EBuildingInfo entity){
        //TODO 做一些数据校验,如唯一约束
    }

    /**
     * 校验并批量删除楼宇基础信息;信息
     *
     * @param ids     待删除的主键集合
     * @param isValid 是否进行有效性校验
     * @return 是否删除成功
     */
    @Override
    public Boolean deleteWithValidByIds(Collection<Long> ids, Boolean isValid) {
        if(isValid){
            //TODO 做一些业务上的校验,判断是否需要校验
        }
        return baseMapper.deleteBatchIds(ids) > 0;
    }

    @Override
    public EBuildingInfoVo selectByCode(String code) {
        return baseMapper.selectVoOne(new LambdaQueryWrapper<EBuildingInfo>().eq(EBuildingInfo::getCode, code));
    }
}
